part of '../adapter/adapter.dart';

@immutable
class MultipartFile {
  final String field;
  final String? filename;
  final MediaType contentType;
  final XHttpContent content;

  MultipartFile.fromBytes({
    required this.field,
    this.filename,
    required this.contentType,
    required Uint8List bytes,
  }) : content = XHttpContent.fromBytes(bytes);

  MultipartFile.fromStream({
    required this.field,
    this.filename,
    required this.contentType,
    required Stream<List<int>> stream,
    required int contentLength,
  }) : content = XHttpContent.fromStream(stream, contentLength: contentLength);

  @override
  bool operator ==(Object other) =>
      other is MultipartFile &&
      other.field == field &&
      other.filename == filename &&
      other.contentType.mimeType == contentType.mimeType &&
      other.content == content;

  @override
  int get hashCode => hashValues(field, filename, contentType.mimeType, content);
}
